=== debian/changelog ===
cups (2.2.10-4.0nosystemd1) nosystemd; urgency=medium

  * nosystemd 

 -- anticapitalista <antix@operamail.com>  Sun, 17 Feb 2019 04:53:51 -0500

cups (2.2.10-4) unstable; urgency=low

  * Backport patches from upstream's 2.2 "stable" branch:
    - Protect against continuing to read from a file at EOF (Issue #5473)
    - Use the same requested-attributes values for all IPP Everywhere setup
      requests (Issue #5484)
    - Add a USB quirk rule for the Lexmark E120n (Issue #5478)
    - Updated the USB quirks rule for Zebra label printers (Issue #5395)
    - Fix compile error on Linux (Issue #5483)
    - Stop parsing the Emulators keywords in PPD files (Issue #5475)
    - Fix potential unaligned accesses in the string pool (Issue #5474)

 -- Didier Raboud <odyx@debian.org>  Sat, 16 Feb 2019 14:48:42 +0100

cups (2.2.10-3) unstable; urgency=medium

  * reprotest errors; cleanup patches:
    - Remove culprit patches refused for upstream integration:
     - patch to implement PRINTER_LIST printer filtering (see #3092)
     - patch to read embedded options from postcript (see #4344)
     - patch to cope with newline in device IDs (see #4345)
    - Update no-conffile-timestamp.patch for syntax bug

 -- Didier Raboud <odyx@debian.org>  Fri, 14 Dec 2018 12:53:56 +0100

cups (2.2.10-2) unstable; urgency=medium

  [ Helge Kreutzmann ]
  * Update German man page (2192t)

 -- Didier Raboud <odyx@debian.org>  Fri, 14 Dec 2018 11:46:51 +0100

cups (2.2.10-1) unstable; urgency=medium

  * New 2.2.10 upstream release
    - CVE-2018-4700: Linux session cookies used a predictable random number
      seed (Closes: #915909)
  * Manpage translations refresh
  * Drop superfluous dpkg-dev B-D

 -- Didier Raboud <odyx@debian.org>  Sat, 08 Dec 2018 12:58:43 +0100

cups (2.2.9-4) unstable; urgency=medium

  * Cherry-pick from upstream:
    - Fix handling of MaxJobTime 0
      (Issue #5438, LP: #1804576, Closes: #915724)

 -- Didier Raboud <odyx@debian.org>  Thu, 06 Dec 2018 19:05:22 +0100

cups (2.2.9-3) unstable; urgency=medium

  * debian/control cleanup:
    - Refresh thanks to `cme fix dpkg-control`
    - Drop xpp suggest
    - Bump S-V to 4.2.1 without changes needed

  * Replace revert with upstream patch to fix `lpadmin -E` regression
    (Issue #5440)

 -- Didier Raboud <odyx@debian.org>  Wed, 05 Dec 2018 22:45:00 +0100
