## cups 2.2.12

=== debian/changelog ===
cups (2.2.12-2ubuntu1.1) eoan-security; urgency=medium

  * SECURITY UPDATE: information disclosure via OOB read
    - debian/patches/CVE-2019-2228.patch: fix ippSetValueTag validation of
      default language in cups/ipp.c.
    - CVE-2019-2228
  * SECURITY UPDATE: heap-based buffer overflow
    - debian/patches/CVE-2020-3898.patch: properly handle invalid
      resolution names in cups/ppd.c, ppdc/ppdc-source.cxx.
    - CVE-2020-3898

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 24 Apr 2020 10:39:27 -0400

cups (2.2.12-2ubuntu1) eoan; urgency=medium

  * Add workaround for systemd's lack of true launch-on-demand
    support (Upstream issue #5640).

 -- Till Kamppeter <till.kamppeter@gmail.com>  Fri,  5 Sep 2019 19:03:01 +0200

cups (2.2.12-2) unstable; urgency=medium

  [ Helge Kreutzmann ]
  * Update German man page (2193t)

 -- Didier Raboud <odyx@debian.org>  Fri, 30 Aug 2019 18:19:57 +0200

cups (2.2.12-1) unstable; urgency=medium

  * New 2.2.12 upstream release
    - CVE-2019-8696 and CVE-2019-8675: Fixed SNMP buffer overflows
      (Closes: #934957)

  * Remove 11 backported patches
  * Fix CVE-2018-4{7,8}00 typo retrospectively in d/changelog
    (Closes: #933985)
  * Refresh debian/gitlab-ci.yml
  * Refresh manpage translations

 -- Didier Raboud <odyx@debian.org>  Sat, 17 Aug 2019 15:51:30 +0200

cups (2.2.10-6) unstable; urgency=medium

  * Backport patch from upstream's 2.2 "stable" branch:
    - Fix an issue with `PreserveJobHistory` and time values (Issue #5538)
      (Closes: #921741)

 -- Didier Raboud <odyx@debian.org>  Tue, 23 Apr 2019 08:33:01 +0200

cups (2.2.10-5) unstable; urgency=medium

  [ Helge Kreutzmann ]
  * Correct error in german manpage translation

  [ Didier Raboud ]
  * Backport patches from upstream's 2.2 "stable" branch:
    - Add USB quirks rule for Xerox printers (Issue #5523)
    - Add a USB quirks rule for the DYMO 450 Turbo (Issue #5521)

 -- Didier Raboud <odyx@debian.org>  Wed, 27 Mar 2019 17:13:07 +0100
