=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: cups
-Maintainer: Debian Printing Team <debian-printing@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Printing Team <debian-printing@lists.debian.org>
 Uploaders: Didier Raboud <odyx@debian.org>,
            Till Kamppeter <till.kamppeter@gmail.com>
 Section: net
@@ -27,6 +28,7 @@
                libpam0g-dev,
                libpaper-dev,
                libpng-dev,
+               libsystemd-dev [linux-any],
                libtiff-dev,
                libusb-1.0-0-dev [!hurd-any],
                po4a,
@@ -102,7 +104,7 @@
           printer-driver-hpcups,
           hplip,
           cups-pdf,
-          udev | eudev,
+          udev,
           smbclient
 Pre-Depends: ${misc:Pre-Depends}
 Breaks: cups-bsd (<< 1.7.2-3~)
@@ -168,7 +170,7 @@
           printer-driver-hpcups,
           hplip,
           cups-pdf,
-          udev | eudev,
+          udev,
           smbclient
 Breaks: cups (<< 2.1.0-6~)
 Replaces: cups (<< 2.1.0-6~)
