## cups 2.2.13

=== debian/changelog ===
cups (2.2.13-0mx19) mx; urgency=medium

  * New upstream release
  * Build for MX-19

 -- Timothy E. Harris <maintainer@mxrepo.com>  Sun, 29 Nov 2020 14:14:09 -0500

cups (2.2.10-6+deb10u3) buster; urgency=medium

  * Backport upstream security fixes:
    - CVE-2020-3898: heap-buffer-overflow in libcups’s ppdFindOption()
      function in ppd-mark.c
    - CVE-2019-8842: The `ippReadIO` function may under-read an extension
      field

 -- Didier Raboud <odyx@debian.org>  Sat, 25 Apr 2020 16:27:21 +0200

cups (2.2.10-6+deb10u2) buster; urgency=medium

  * Backport upstream security fixes:
    - Fix memory leak in ppdOpen (Closes: #946941)
    - CVE-2019-2228: The `ippSetValuetag` function did not validate the
      default language value (Closes: #946782)

 -- Didier Raboud <odyx@debian.org>  Sun, 19 Jan 2020 09:36:31 +0100

cups (2.2.10-6+deb10u1) buster; urgency=medium

  * Fix multiple security/disclosure issues (Closes: #934957)
    - CVE-2019-8696 and CVE-2019-8675: Fixed SNMP buffer overflows
    - Fixed IPP buffer overflow
    - Fixed memory disclosure issue in the scheduler
    - Fixed DoS issues in the scheduler

 -- Didier Raboud <odyx@debian.org>  Wed, 21 Aug 2019 09:43:13 +0200
